# $Id: psenv.sh.in,v 1.21 2012/05/01 22:08:23 ruiliu Exp $

############################################################################
#
#                    University of Illinois/NCSA
#                        Open Source License
# 
#          Copyright(C) 2004-2010, The Board of Trustees of the
#              University of Illinois. All rights reserved.
#
#                            Developed by:             
# 
#                        The PerfSuite Project
#            National Center for Supercomputing Applications
#              University of Illinois at Urbana-Champaign
# 
#                   http://perfsuite.ncsa.uiuc.edu/
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal with the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense, 
# and/or sell copies of the Software, and to permit persons to whom the 
# Software is furnished to do so, subject to the following conditions:
# 
# + Redistributions of source code must retain the above copyright notice, 
#   this list of conditions and the following disclaimers.
# + Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimers in
#   the documentation and/or other materials provided with the distribution.
# + Neither the names of The PerfSuite Project, NCSA/University of Illinois
#   at Urbana-Champaign, nor the names of its contributors may be used to
#   endorse or promote products derived from this Software without specific
#   prior written permission.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
# CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
# DEALINGS WITH THE SOFTWARE.
############################################################################

# psenv.sh: convenience script to set PerfSuite environment variables
#
# Usage: $ source /usr/bin/psenv.sh
#                  (or)
#        $ . /usr/bin/psenv.sh
#
# This script was automatically generated during PerfSuite configuration
# from "psenv.sh.in".

echo $PATH | egrep -q ':/usr/bin:|:/usr/bin$|^/usr/bin:|^/usr/bin$'
if test $? != 0 ; then
    # echo "PATH does not contain it."
    PATH=/usr/bin:$PATH
fi

if test "x$LD_LIBRARY_PATH" = "x" ; then
    LD_LIBRARY_PATH=/usr/lib
else
    echo $LD_LIBRARY_PATH | egrep -q ':/usr/lib:|:/usr/lib$|^/usr/lib:|^/usr/lib$'
    if test $? != 0 ; then
        LD_LIBRARY_PATH=/usr/lib:$LD_LIBRARY_PATH
    fi
fi

if test "x/usr/lib/papi-5.1.1/usr/lib" != "x" ; then
    echo $LD_LIBRARY_PATH | egrep -q ':/usr/lib/papi-5.1.1/usr/lib:|:/usr/lib/papi-5.1.1/usr/lib$|^/usr/lib/papi-5.1.1/usr/lib:|^/usr/lib/papi-5.1.1/usr/lib$'
    if test $? != 0 ; then
        LD_LIBRARY_PATH=/usr/lib/papi-5.1.1/usr/lib:$LD_LIBRARY_PATH
    fi
fi

if test "x" != "x"; then
    echo $LD_LIBRARY_PATH | egrep -q '::|:$|^:|^$'
    if test $? != 0 ; then
        LD_LIBRARY_PATH=:$LD_LIBRARY_PATH
    fi
fi

if test "x$TCLLIBPATH" = "x" ; then
    TCLLIBPATH=/usr/share/perfsuite/tcllib
else
    echo $TCLLIBPATH | egrep -q ' /usr/share/perfsuite/tcllib | /usr/share/perfsuite/tcllib$|^/usr/share/perfsuite/tcllib |^/usr/share/perfsuite/tcllib$'
    if test $? != 0 ; then
        TCLLIBPATH="/usr/share/perfsuite/tcllib $TCLLIBPATH"
    fi
fi

if test "x$MANPATH" != "x" ; then
    echo $MANPATH | egrep -q ':/usr/share/man:|:/usr/share/man$|^/usr/share/man:|^/usr/share/man$'
    if test $? != 0 ; then
        MANPATH=/usr/share/man:$MANPATH
    fi
fi

export PATH LD_LIBRARY_PATH TCLLIBPATH CLASSPATH MANPATH
