! $Id: cpi-mpif.f,v 1.3 2004/08/30 01:02:29 rkufrin Exp $

!
! cpi-mpif: Fortran 77 MPI-based program for approximation of pi
!

      program mpif
      implicit none
      include 'mpif.h'

      integer done, n, myid, numprocs, namelen, i, ierr
      double precision mypi, pi, h, sum, x, startwtime, endwtime
      character*(MPI_MAX_PROCESSOR_NAME) processor_name
      double precision PI25DT
      parameter (PI25DT = 3.141592653589793238462643)
      double precision f
      external f

      done = 0
      startwtime = 0.0

      call MPI_Init(ierr)
      call MPI_Comm_size(MPI_COMM_WORLD, numprocs, ierr)
      call MPI_Comm_rank(MPI_COMM_WORLD, myid, ierr)
      call MPI_Get_processor_name(processor_name, namelen, ierr)

      write(6, 10) myid, processor_name
10    format(1x, 'Process ', i5, ' on ', a32)

      n = 0
      do while ( done .eq. 0 )
          if ( myid .eq. 0) then
              if ( n .eq. 0 ) then
                  n = 10000000
              else 
                  n = 0
              endif

              startwtime = MPI_Wtime()
          endif
          call MPI_Bcast(n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ierr)
          if ( n .eq. 0 ) then
              done = 1
          else 
              h   = 1.0 / real(n)
              sum = 0.0
              do 100 i = myid + 1, n, numprocs
                  x = h * (real(i) - 0.5)
                  sum = sum + f(x)
100           continue
              mypi = h * sum

              call MPI_Reduce(mypi, pi, 1, MPI_DOUBLE_PRECISION,
     +                        MPI_SUM, 0, MPI_COMM_WORLD, ierr)

              if ( myid .eq. 0 ) then
                  print *, 'pi is approximately ', pi
                  print *, ' Error is ', dabs(pi - PI25DT)
                  endwtime = MPI_Wtime()
                  print *, 'wall clock time = ', endwtime-startwtime
              endif
          endif
      end do

      call MPI_Finalize(ierr)

      stop
      end

      double precision function f(a)
      double precision a

      f = 4.0 / (1.0 + a*a)

      return
      end
