! $Id: cpi-ompf.f,v 1.1 2005/01/13 03:29:58 rkufrin Exp $
!
! cpi-omp: Fortran OpenMP version of pi calculation
!
! This program was adapted from an example appearing in the
! article "OpenMP: A Proposed Industry Standard API for Shared
! Memory Programming" by Leo Dagum (http://www.openmp.org/).
!

      program compute_pi
      integer n, i, omp_get_thread_num
      double precision w, x, sum, pi, f, a
      character*32 arg1

c function to integrate
      f(a) = 4.d0 / (1.d0 + a*a)

c     print *, 'Enter number of intervals: '
c     read *, n
      if (iargc() .ne. 1) then
        print *, 'Usage: cpi-omp num_intervals'
        stop
      endif
      call getarg(1, arg1)
      read (arg1, '(i)') n 
!$OMP PARALLEL
      print *, 'Hello from thread ', omp_get_thread_num()
!$OMP END PARALLEL

c calculate the interval size
      w = 1.0d0/n
      sum = 0.0d0

!$OMP PARALLEL DO PRIVATE(x), SHARED(w)
!$OMP& REDUCTION(+: sum)
      do i = 1, n
        x = w * (i - 0.5d0)
        sum = sum + f(x)
      enddo
      pi = w * sum

      print *, 'computed pi = ', pi

      stop
      end
