# $Id: readxml.tcl,v 1.6 2009/02/17 19:44:40 rkufrin Exp $

############################################################################
#
#                    University of Illinois/NCSA
#                        Open Source License
# 
#          Copyright(C) 2004-2006, The Board of Trustees of the
#              University of Illinois. All rights reserved.
#
#                            Developed by:             
# 
#                        The PerfSuite Project
#            National Center for Supercomputing Applications
#              University of Illinois at Urbana-Champaign
# 
#                   http://perfsuite.ncsa.uiuc.edu/
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal with the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense, 
# and/or sell copies of the Software, and to permit persons to whom the 
# Software is furnished to do so, subject to the following conditions:
# 
# + Redistributions of source code must retain the above copyright notice, 
#   this list of conditions and the following disclaimers.
# + Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimers in
#   the documentation and/or other materials provided with the distribution.
# + Neither the names of The PerfSuite Project, NCSA/University of Illinois
#   at Urbana-Champaign, nor the names of its contributors may be used to
#   endorse or promote products derived from this Software without specific
#   prior written permission.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
# CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
# DEALINGS WITH THE SOFTWARE.
############################################################################

# readxml: acquire XML data from URI passed in.  Return as a string.
# 
# @@ This should be moved to a general purpose package along with uri.tcl
#
# Author: Rick Kufrin
# Date:   January 18, 2004
#
# This file is part of PerfSuite.

proc readxml {xmlFile} {
    global psprocessVersion
    
    # Acquire the XML data
    if { [isuri $xmlFile] } {
        psdebug 1 "Doing HTTP query"
        set agent "PerfSuite psprocess $psprocessVersion\
                   http://perfsuite.ncsa.uiuc.edu/"
        set timeout 20000
        if { [catch {fetchuri $xmlFile $timeout $agent} xmlData] } {
            error "$xmlData"
        }
    } else {
        if { $xmlFile == "stdin" } {
            set xmlfd stdin
        } elseif { [catch {open $xmlFile "r"} xmlfd] } {
            error "$xmlfd"
        }
        set xmlData [read $xmlfd]
        if { $xmlFile != "stdin" } {
            close $xmlfd
        }
    }
    return $xmlData
}
