# $Id: version.tcl,v 1.2 2009/10/19 16:08:58 rkufrin Exp $

############################################################################
#
#                      University of Illinois/NCSA
#                          Open Source License
# 
#          Copyright(C) 2002-2009, The Board of Trustees of the
#              University of Illinois. All rights reserved.
#
#                             Developed by:             
# 
#                        The PerfSuite Project
#            National Center for Supercomputing Applications
#              University of Illinois at Urbana-Champaign
# 
#                   http://perfsuite.ncsa.uiuc.edu/
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal with the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense, 
# and/or sell copies of the Software, and to permit persons to whom the 
# Software is furnished to do so, subject to the following conditions:
# 
# + Redistributions of source code must retain the above copyright notice, 
#   this list of conditions and the following disclaimers.
# + Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimers in
#   the documentation and/or other materials provided with the distribution.
# + Neither the names of The PerfSuite Project, NCSA/University of Illinois
#   at Urbana-Champaign, nor the names of its contributors may be used to
#   endorse or promote products derived from this Software without specific
#   prior written permission.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
# CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
# DEALINGS WITH THE SOFTWARE.
############################################################################

# version.tcl: Report current version number of psprocess
#
# Author: Rick Kufrin
#
# This file is part of PerfSuite.

set psprocessVersion 0.5

proc version {} {
    global psprocessVersion env

    if { [info exists env(PS_VERSION)] } {
        set packageversion $env(PS_VERSION)
    } else {
        set packageversion "(N/A)"
    }

    puts "\t--------------------------------------------"
    puts "\t              PerfSuite $packageversion"
    puts "\t         psprocess (Tcl version $psprocessVersion)"
    puts ""
    puts "\t         University of Illinois/NCSA"
    puts "\t             Open Source License"
    puts ""
#    puts "\t   Email: perfsuite-users@lists.sourceforge.net"
    puts "\t       http://perfsuite.ncsa.uiuc.edu/"
    puts "\t      http://perfsuite.sourceforge.net/"
    puts "\t--------------------------------------------"
}

