<?xml version="1.0" ?>

<!--

$Id: hwpcprofilereport.xsl.in,v 1.2 2005/08/18 13:26:00 rkufrin Exp $

/****************************************************************************
 *
 *                      University of Illinois/NCSA
 *                          Open Source License
 * 
 *            Copyright(C) 2005, The Board of Trustees of the
 *              University of Illinois. All rights reserved.
 * 
 *                             Developed by:             
 * 
 *                        The PerfSuite Project
 *            National Center for Supercomputing Applications
 *              University of Illinois at Urbana-Champaign
 * 
 *                   http://perfsuite.ncsa.uiuc.edu/
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal with the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 * 
 * + Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimers.
 * + Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimers in
 *   the documentation and/or other materials provided with the distribution.
 * + Neither the names of The PerfSuite Project, NCSA/University of Illinois
 *   at Urbana-Champaign, nor the names of its contributors may be used to
 *   endorse or promote products derived from this Software without specific
 *   prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS WITH THE SOFTWARE.
 ****************************************************************************/

 hwpcprofilereport.xsl: XSLT stylesheet for transforming a PerfSuite
                        <hwpcprofilereport> to XHTML.

 Author: Rick Kufrin
 Date:   2005/08/17

 This file is part of PerfSuite.
-->


<xsl:transform version="1.0"
              xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:variable name="fmt">0.##</xsl:variable>

  <xsl:variable name="totalsamples">
    <xsl:value-of select="//totalsamples" />
  </xsl:variable>

  <xsl:template match="/">
    <html>
      <head>
        <title>PerfSuite Profile Report</title>
        <link rel="stylesheet" type="text/css" href="file:///usr/share/perfsuite/xml/pshwpc/hwpcprofilereport.css" />
      </head>

      <body>
        <table>
          <tr>
            <th>Function</th><th>File</th><th>% Samples</th>
          </tr>
    <xsl:for-each select="//function">
          <tr>
            <td>
      <xsl:value-of select="@name" />
            </td>
            <td>
      <xsl:value-of select="../@name" />
            </td>
            <td>
      <xsl:value-of
        select="format-number(sum(line) div $totalsamples * 100.0,$fmt)"/>
            </td>
          </tr>
    </xsl:for-each>
        </table>
      </body>
    </html>
  </xsl:template>

</xsl:transform>
